local camera = {};
dx , dy = 0 , 0;
scale_val = 1;
mousex = love.mouse.getX();
mousey = love.mouse.getY();
prev_mousex, prev_mousey = mousex , mousey;
center_speed = 5;
cam_step = 500; --cam movement speed
cam_scroll = 30; --cam zoom speed/scroll
middle_move_sens = 1; --cam pan around speed (middle mouse button)
screen_width = love.graphics.getWidth();
screen_height = love.graphics.getHeight();

function camera:cmove()
  
  wkey = love.keyboard.isDown('w', "up");  --Take input
  skey = love.keyboard.isDown('s', "down");
  akey = love.keyboard.isDown('a',"left");
  dkey = love.keyboard.isDown('d', "right");
  mouse_x, mouse_y = love.mouse.getPosition()
  dt = love.timer.getDelta() --delta time
  
      --[[cam movement]]--
    if (wkey) then
      dy = dy + (cam_step * (1/scale_val) * dt);
      end
    
    if (skey) then
      dy = dy - (cam_step * (1/scale_val) * dt);
      end
    
    if(akey) then
      dx = dx + (cam_step * (1/scale_val) * dt);
      end
    
    if(dkey) then
      dx = dx - (cam_step * (1/scale_val) * dt);
    end
    
        --[[cam zoom]]--
      function love.wheelmoved(x, y)
        if (y > 0) then
              scale_val = scale_val + (cam_scroll * y * dt);
              dx = dx + mouse_x
              --dy = dy - mouse_y
        elseif (y < 0) then
          if not (scale_val-(cam_scroll*dt)<=0) then
             
              scale_val = scale_val - (cam_scroll * dt * -y);
            end
        end
      end
      
      --[[middle mouse click drag cam]]--
      if love.mouse.isDown(3) then --middle mouse button = 3
          prev_mousex = mousex;
          prev_mousey = mousey;
          mousex = love.mouse.getX()
          mousey = love.mouse.getY()
          
          dx = dx + (mousex - prev_mousex) * (middle_move_sens * (1/scale_val));
          dy = dy + (mousey - prev_mousey) * (middle_move_sens * (1/scale_val));
      else 
          mousex , prev_mousex = love.mouse.getX()
          mousey , prev_mousey = love.mouse.getY()
      end
      
      print(mouse_x,dx)
      
  love.graphics.translate(dx, dy);
  love.graphics.scale(scale_val, scale_val);
  
  
end



return camera